import { defineStore } from "pinia";
import { ref } from "vue";
import _ from "underscore";
import type { LoginResult } from "@/types/user";
// 定义 Store
export const useMemberStore = defineStore(
  "member",
  () => {
    // 会员信息
    const profile = ref<LoginResult>({
      token: '',
      userInfo: {
        userName: "",
        factoryName: "",
      },
      menusList:[],
      menusNameList: []
    });

    // 保存会员信息，登录时使用
    const setProfile = (val: any) => {
      profile.value = val;
      profile.value.menusNameList = _.pluck(val.menusList, "name");
    };

    // 清理会员信息，退出时使用
    const clearProfile = () => {
      // profile.value = undefined
    };

    // 记得 return
    return {
      profile,
      setProfile,
      clearProfile,
    };
  },
  {
    // 配置持久化
    persist: {
      // 调整为兼容多端的API
      storage: {
        setItem(key, value) {
          uni.setStorageSync(key, value);
        },
        getItem(key) {
          return uni.getStorageSync(key);
        },
      },
    },
  }
);
